<!DOCTYPE html>
<html>
<head>
    <title>Poka Yoke</title>

    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <style>
        body {
            font-family: Arial, sans-serif;
            margin: 0;
            padding: 0;
            display: flex;
            flex-direction: column;
            align-items: center;
        }

        /* 一般的なスタイル */
        .content {
            width: 90%;
            max-width: 600px; /* 最大幅を設定して中央に配置 */
            margin: 20px;
            padding: 20px;
            box-shadow: 0 0 10px rgba(0,0,0,0.1);
        }

        /* 480px以下のデバイスに適用するスタイル */
        @media (max-width: 480px) {
            .content {
                margin: 10px;
                padding: 10px;
            }
        }
    </style>
</head>


<body>
    <input type = "text" id="bcdata" placeholder="バーコードを入力" autofocus>
    <button id="clearBtn">マスタデータクリア</button>
    <input type="text" id="partialMatchInput" placeholder="Enter data for partial match" style="display: none;">
    <p id="result"></p>
    <h4>モード選択</h4>
    <select id="modeSelect">
        <option value="oneToOne">1 対 1照合</option>
        <option value="oneToN">1 対 N 照合</option>
        <option value="treasureHunt">宝探しモード</option>
        <option value="partialMatch">部分一致モード</option>
    </select>

    <script>
        document.oncontextmenu = function () {return false;}
        let masterData = null;
        modeSelect.addEventListener('change', function() {
            partialMatchInput.style.display = this.value === 'partialMatch' ? '' : 'none';
        });

        document.addEventListener("DOMContentLoaded", function() {

        document.getElementById('result').textContent = 'マスタデータを登録してください。';


            // テキストフィールドの要素を取得
            //var inputElement = document.getElementById("bcdata");
            
           
            document.getElementById('bcdata').addEventListener('change', function(e) {
                
                // inputイベントのリスナーを追加
                //inputElement.addEventListener("input", function(e) {
               
                // 入力されたテキストデータを取得
                const barcode = e.target.value;
                displayResult(barcode,"");
                e.target.value = "";
                // ここで取得したテキストデータを使用する
                // 例: コンソールに出力
                console.log(barcode)
                onScanSuccess(barcode);
            });


      });



        document.getElementById('clearBtn').addEventListener('click', () => {
            masterData = null;
            document.getElementById('result').textContent = 'マスタデータをクリアしました。再度登録してください。';
        });


        function onScanSuccess(scannedText) {
     
            if (modeSelect.value === 'partialMatch') {
                const partialData = partialMatchInput.value;
                if (scannedText.includes(partialData)) {
                    displayResult(scannedText, "⭕️");
                } else {
                    displayResult("一致しない", "");
                }
                return;
            }

            if (masterData === null) {
                masterData = scannedText;
                displayResult(scannedText, "⭕️");
            } else {
                switch (modeSelect.value) {
                    case "oneToOne":
                        displayResult(scannedText, scannedText === masterData ? "⭕️" : "❌");
                        break;
                    case "oneToN":
                        if (scannedText === masterData) {
                            displayResult("一致", "");
                        } else {
                            displayResult(scannedText, "❌");
                        }
                        break;
                    case "treasureHunt":
                        displayResult(scannedText, scannedText === masterData ? "⭕️" : "一致しない");
                        break;
                    default:
                        break;
                }
            }
        }

        function displayResult(data, symbol) {
            document.getElementById('result').textContent = `${data} ${symbol}`;
        }
    </script>

</body>
</html>
